package com.yutou.tools.mybatis.model;

import java.io.Serializable;
import lombok.Data;

/**
 * music_data
 * @author 
 */
@Data
public class MusicData implements Serializable {
    private Integer id;

    /**
     * 艺术家
     */
    private String artist;

    /**
     * 专辑
     */
    private String album;

    /**
     * 标题
     */
    private String title;

    /**
     * 评论
     */
    private String comment;

    /**
     * 年份
     */
    private String year;

    /**
     * 音轨号
     */
    private String track;

    /**
     * 碟片编号
     */
    private String discNo;

    /**
     * 作曲
     */
    private String composer;

    /**
     * 分类
     */
    private String artistSort;

    /**
     * 音乐文件路径
     */
    private String file;

    /**
     * 上一个文件夹
     */
    private String lastdir;

    private Integer isdir;

    /**
     * 比特率
     */
    private Integer bitrate;

    /**
     * 采样率
     */
    private Integer samplerate;

    /**
     * 采样数
     */
    private Long noofsamples;

    /**
     * 声道
     */
    private Integer channelcount;

    /**
     * 解码类型
     */
    private String encodingtype;

    /**
     * 持续时长
     */
    private Double durationasdouble;

    /**
     * 无损
     */
    private Integer lossless;

    /**
     * 固定码率
     */
    private Integer variablebitrate;

    /**
     * md5
     */
    private String md5;

    private static final long serialVersionUID = 1L;
}