package com.yutou.tools.other;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yutou.tools.ToolsApplication;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.Enumeration;

@Controller
public class tools {

    @ResponseBody
    @RequestMapping(value = "tools/cookie.do",method = RequestMethod.POST)
    public String cookieToJson(HttpServletRequest request){
        JSONObject json=new JSONObject();
        JSONArray array=new JSONArray();
        for (Cookie cookie : request.getCookies()) {
            JSONObject item=new JSONObject();
            item.put("name",cookie.getName());
            item.put("value",cookie.getValue());
            item.put("domain",cookie.getDomain());
            item.put("path",cookie.getPath());
            item.put("maxAge",cookie.getMaxAge());
            item.put("secure",cookie.getSecure());
            item.put("isHttpOnly",cookie.isHttpOnly());
            array.add(item);
        }
        json.put("data",array);
        return json.toJSONString();
    }
    @ResponseBody
    @RequestMapping(value = "tools/get.do")
    public String getJs(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Enumeration<String> name=request.getHeaderNames();
        while (name.hasMoreElements()){
            String na=name.nextElement();
            System.out.println(na+" "+request.getHeader(na));
        }
        File file=new File("D:\\IDEA\\web_toolset\\web\\js\\my.js");
        BufferedReader reader=new BufferedReader(new FileReader(file));
        String tmp,str="";
        while ((tmp=reader.readLine())!=null){
            if(tmp.contains("\"")){
               // tmp=tmp.replace("\"","\\\"");
            }
            str+=tmp;
        }
        reader.close();
      /*  response.setHeader("Content-Type","application/javascript; charset=utf-8");
        PrintWriter writer=response.getWriter();
        writer.write(str);
        writer.flush();
        writer.close();*/
      return str;
        //return "function test(){ return \"https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1588139022200&di=8cc8405f7514dd54bd82fcd070349603&imgtype=0&src=http%3A%2F%2Fa2.att.hudong.com%2F36%2F48%2F19300001357258133412489354717.jpg\" }";
    }
    @RequestMapping("/public/version.do")
    @ResponseBody
    public String getVersion(){
        return ToolsApplication.version;
    }
}
